@echo off
rem ANSIPRMT.BAT by Jim Groeneveld, Schoolweg 14, 8071 BC Nunspeet, Nederland.

rem Disclaimer
rem ----------
rem The author is not liable for any negative consequences of the use or misuse
rem of this program.

 rem                                   1st check on ANSI.SYS:
ansichk>nul
if errorlevel 2 goto ChkAnsi           If not succeeded do 2nd check
if errorlevel 1 goto AnsiYes           If ANSI.SYS detected proceed processing
 rem                                   Errorlevel=0: ANSI.SYS not (yet) detected
:ChkAnsi                               2nd check on ANSI.SYS:
chkansi>nul
 rem Only one check should be sufficient. Both are included here only for
 rem demonstration purposes. If both yield different results or if one or
 rem both yield erroneous results they should be recompiled with different
 rem settings in their .H files: see CHKANSI.DOC for more information.
if errorlevel 2 goto AnsiNo            Uncertain about ANSI.SYS

 rem Set ANSI environment variable based on errorlevel from CHKANSI
if errorlevel 1 goto AnsiYes
:AnsiNo                                Errorlevel = 0 or  2
set ANSI=NO
goto AnsiSet                           No ANSI.SYS use

:AnsiYes                               Errorlevel = 1
set ANSI=YES
:AnsiSet

if not "%ANSI%"=="YES" goto NoAnsiPrompt
 rem Be sure to have enough environment space for such a long prompt.
 rem Environment space may be set from CONFIG.SYS using SHELL=...../E:size
PROMPT=$e[s$e[?7l$e[;44H$e[0;30;42m$v $e[;32H$e[37;44m $d $t$e[3D $e[1;33;41m$e[H$p$e[0;30;47m $e[u$n$g$e[?7h$e[34m
 rem (Instead of '' I report the task number of a multitasking shell.)

 rem It may be necessary to change the column value 44 in the substring $e[;44H
 rem into some other value in order to correctly display your MSDOS version in
 rem the right corner of the screen. The '$v' parameter returns the same as the
 rem MSDOS command 'ver' and parts of that are overwritten or truncated here.

 rem It is possible to replace the '$e' strings by single real ESC characters,
 rem to obtain more space for the whole prompt string (which now is not far
 rem from the maximum size). Similarly it is possible to replace the string
 rem '$e3D' by '$h$h$h' or better '###', in which # represents the real
 rem backspace character, ascci-8. This causes the prompt to be interpreted
 rem instead of only literally displayed with the DOS SET command, no problem.

 rem One might insert a '$e[H$e[K' (with $e replaced by ascii-27 too)
 rem right after the '[?7l' part to force a clear of the top line firstly.
 rem Some programs, however, print something important on the top line at exit
 rem and that may become (partially) invisible by being overwritten.

 rem Furthermore this prompt may be adapted according to your own desires to
 rem change colours (e.g. on monochrome screens) and strings. For more info
 rem see your DOS manuals on PROMPT and ANSI.SYS.

 rem QWIKANSI.SYS ((C) 1986, Michael J. Acker) has some problem with the escape
 rem codes '$e[?7l' and '$e[?7h': any next character if recognized as a valid
 rem escape code ending character (like a, h, l, m, H, etc.) is not displayed,
 rem but interpreted as such. If the escape sequence was the last one within
 rem the prompt the first entered character from the keyboard is misused as
 rem such and it is yet also the first character of the DOS command line. Bug!

goto End                               ANSI prompt set

:NoAnsiPrompt                          Any regular prompt you may wish:
prompt $p$g

:End           of ANSIPRMPT.BAT        (leave at least 5 spaces after ':End')
 rem Labels are unique up to 8 characters; the exceeding ones are ignored and
 rem may be used for any comment, as demonstrated.
